#include <Servo.h>


Servo myservo;
const int buttonPin1 = 2;
const int buttonPin2 = 4;
int buttonState = 0;
const int potar = A0;
int valPotarT1 = 0;
int valPotarT2 = 0;
int step_comparaison_potar = 10;
int commande_arret_moteur = 92;
bool onForce = false;
bool finDeroulage = false;
int delai =200;


void setup() {
    Serial.begin(9600);
    myservo.attach(10);
    pinMode(buttonPin1, INPUT_PULLUP);
    pinMode(buttonPin2, INPUT_PULLUP);
    pinMode(potar, INPUT);
}

void loop() {

  buttonState = digitalRead(buttonPin1);
  
  if ((buttonState == LOW) && (onForce==false) ) {
    finDeroulage = false;
    
    myservo.write(80);

    valPotarT1 = analogRead(potar);
    delay(delai);
    valPotarT2 = analogRead(potar);
    
    if(abs(valPotarT2 - valPotarT1) <= step_comparaison_potar){
      myservo.write(commande_arret_moteur);
      onForce = true;
    }
  }

  else{
    buttonState = digitalRead(buttonPin2);
    if (buttonState == HIGH){
      myservo.write(commande_arret_moteur);
    }
  }

  //On passe à la lecture du bouton 2
  
  buttonState = digitalRead(buttonPin2);
  
  if ((buttonState == LOW) && (finDeroulage==false) ) {
    onForce = false; 
    myservo.write(100);

    valPotarT1 = analogRead(potar);
    delay(delai);
    valPotarT2 = analogRead(potar);
    
    if(abs(valPotarT2 - valPotarT1) <= step_comparaison_potar){
      myservo.write(commande_arret_moteur);
      finDeroulage = true;
      //Si on est en fin de déroulage on referme un peu (l'accès est toujours interdit ensuite)
      myservo.write(80);
      delay(800);
      myservo.write(commande_arret_moteur);
    }
  }

  else{
    buttonState = digitalRead(buttonPin1);
    if (buttonState == HIGH){
      myservo.write(commande_arret_moteur);
    }
  }
}

